From 43b09196ca9765656c8d787efc18b54b9d0e7ff9 Mon Sep 17 00:00:00 2001
From: Melih Mutlu <m.melihmutlu@gmail.com>
Date: Wed, 13 Dec 2023 15:02:21 +0300
Subject: [PATCH] Consider JIT per plan node

Currently, if JIT is enabled, the decision for JIT compilation relies
on the total cost of the query. The number of expressions to be JIT
compiled is not taken into consideration, however the time spent JITing
depends on that number. This may cause the cost of JITing to become
too much that it hurts rather than improves anything.

This patch changes consideration of JIT from plan level to per-plan-node
level. Instead of depending on the total cost, we decide whether to
JIT a node or not by considering that node's cost. This allows us
to only JIT compile plan nodes with costs higher than jit_above_cost.
---
 contrib/file_fdw/file_fdw.c                   |   6 +-
 .../postgres_fdw/expected/postgres_fdw.out    |  16 +-
 contrib/postgres_fdw/postgres_fdw.c           |   9 +-
 doc/src/sgml/config.sgml                      |  24 +-
 src/backend/commands/explain.c                |  25 +-
 src/backend/jit/jit.c                         |   8 +
 src/backend/optimizer/path/costsize.c         |   1 +
 src/backend/optimizer/plan/createplan.c       | 796 ++++++++++++------
 src/backend/optimizer/plan/planner.c          |  16 +-
 src/backend/optimizer/plan/subselect.c        |  11 +-
 src/backend/optimizer/util/pathnode.c         |   6 +
 src/include/foreign/fdwapi.h                  |   5 +-
 src/include/nodes/pathnodes.h                 |   2 +
 src/include/nodes/plannodes.h                 |   7 +
 src/include/optimizer/planmain.h              |  20 +-
 src/test/regress/expected/explain.out         |  61 +-
 src/test/regress/expected/inherit.out         |   9 +-
 src/test/regress/expected/select_parallel.out |   7 +-
 src/test/regress/expected/with.out            |   6 +-
 19 files changed, 700 insertions(+), 335 deletions(-)

diff --git a/contrib/file_fdw/file_fdw.c b/contrib/file_fdw/file_fdw.c
index 2189be8a3c..45350341a6 100644
--- a/contrib/file_fdw/file_fdw.c
+++ b/contrib/file_fdw/file_fdw.c
@@ -125,7 +125,8 @@ static void fileGetForeignRelSize(PlannerInfo *root,
 static void fileGetForeignPaths(PlannerInfo *root,
 								RelOptInfo *baserel,
 								Oid foreigntableid);
-static ForeignScan *fileGetForeignPlan(PlannerInfo *root,
+static ForeignScan *fileGetForeignPlan(CreatePlanContext *context,
+									   PlannerInfo *root,
 									   RelOptInfo *baserel,
 									   Oid foreigntableid,
 									   ForeignPath *best_path,
@@ -596,7 +597,8 @@ fileGetForeignPaths(PlannerInfo *root,
  *		Create a ForeignScan plan node for scanning the foreign table
  */
 static ForeignScan *
-fileGetForeignPlan(PlannerInfo *root,
+fileGetForeignPlan(CreatePlanContext *context,
+				   PlannerInfo *root,
 				   RelOptInfo *baserel,
 				   Oid foreigntableid,
 				   ForeignPath *best_path,
diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index e9144beb62..e8985bba71 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -330,7 +330,8 @@ static void postgresGetForeignRelSize(PlannerInfo *root,
 static void postgresGetForeignPaths(PlannerInfo *root,
 									RelOptInfo *baserel,
 									Oid foreigntableid);
-static ForeignScan *postgresGetForeignPlan(PlannerInfo *root,
+static ForeignScan *postgresGetForeignPlan(CreatePlanContext *context,
+										   PlannerInfo *root,
 										   RelOptInfo *foreignrel,
 										   Oid foreigntableid,
 										   ForeignPath *best_path,
@@ -1219,7 +1220,8 @@ postgresGetForeignPaths(PlannerInfo *root,
  *		Create ForeignScan plan node which implements selected best path
  */
 static ForeignScan *
-postgresGetForeignPlan(PlannerInfo *root,
+postgresGetForeignPlan(CreatePlanContext *context,
+					   PlannerInfo *root,
 					   RelOptInfo *foreignrel,
 					   Oid foreigntableid,
 					   ForeignPath *best_path,
@@ -1386,7 +1388,8 @@ postgresGetForeignPlan(PlannerInfo *root,
 			 * Now fix the subplan's tlist --- this might result in inserting
 			 * a Result node atop the plan tree.
 			 */
-			outer_plan = change_plan_targetlist(outer_plan, fdw_scan_tlist,
+			outer_plan = change_plan_targetlist(context, outer_plan,
+												fdw_scan_tlist,
 												best_path->path.parallel_safe);
 		}
 	}
diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
index f323bba018..73a3dad41a 100644
--- a/doc/src/sgml/config.sgml
+++ b/doc/src/sgml/config.sgml
@@ -5713,8 +5713,11 @@ ANY <replaceable class="parameter">num_sync</replaceable> ( <replaceable class="
       </term>
       <listitem>
        <para>
-        Sets the query cost above which JIT compilation is activated, if
-        enabled (see <xref linkend="jit"/>).
+        Sets the cost threshold for which a given plan node will consider
+        performing JIT compilation for itself. The <literal>total_cost</literal>
+        of a given plan node multiplied by its estimated <literal>loops</literal>
+        must exceed this value before JIT compilation is considered for the
+        plan node, if enabled (see <xref linkend="jit"/>).
         Performing <acronym>JIT</acronym> costs planning time but can
         accelerate query execution.
         Setting this to <literal>-1</literal> disables JIT compilation.
@@ -5731,9 +5734,11 @@ ANY <replaceable class="parameter">num_sync</replaceable> ( <replaceable class="
       </term>
       <listitem>
        <para>
-        Sets the query cost above which JIT compilation attempts to inline
-        functions and operators.  Inlining adds planning time, but can
-        improve execution speed.  It is not meaningful to set this to less
+        Sets the ovarall query plan cost above which JIT compilation attempts
+        to inline functions and operators. Inlining adds planning time, but can
+        improve execution speed. There must be at least one plan node which is
+        decided to perform JIT compilation, inlining will not be considered
+        otherwise. It is not meaningful to set this to less
         than <varname>jit_above_cost</varname>.
         Setting this to <literal>-1</literal> disables inlining.
         The default is <literal>500000</literal>.
@@ -5751,10 +5756,11 @@ ANY <replaceable class="parameter">num_sync</replaceable> ( <replaceable class="
        <para>
         Sets the query cost above which JIT compilation applies expensive
         optimizations.  Such optimization adds planning time, but can improve
-        execution speed.  It is not meaningful to set this to less
-        than <varname>jit_above_cost</varname>, and it is unlikely to be
-        beneficial to set it to more
-        than <varname>jit_inline_above_cost</varname>.
+        execution speed. There must be at least one plan node which is decided
+        to perform JIT compilation, optimizations will not be considered
+        otherwise. It is not meaningful to set this to less than
+        <varname>jit_above_cost</varname>, and it is unlikely to be beneficial
+        to set it to more than <varname>jit_inline_above_cost</varname>.
         Setting this to <literal>-1</literal> disables expensive optimizations.
         The default is <literal>500000</literal>.
        </para>
diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index f1d71bc54e..fc7eae8b97 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -1627,9 +1627,16 @@ ExplainNode(PlanState *planstate, List *ancestors,
 	{
 		if (es->format == EXPLAIN_FORMAT_TEXT)
 		{
-			appendStringInfo(es->str, "  (cost=%.2f..%.2f rows=%.0f width=%d)",
-							 plan->startup_cost, plan->total_cost,
-							 plan->plan_rows, plan->plan_width);
+			/* only display the expected loops if it's above 1.0 */
+			if (plan->est_calls < 1.0)
+				appendStringInfo(es->str, "  (cost=%.2f..%.2f rows=%.0f width=%d)",
+									plan->startup_cost, plan->total_cost,
+									plan->plan_rows, plan->plan_width);
+			else
+				appendStringInfo(es->str, "  (cost=%.2f..%.2f rows=%.0f width=%d loops=%.0f)",
+									plan->startup_cost, plan->total_cost,
+									plan->plan_rows, plan->plan_width,
+									plan->est_calls);
 		}
 		else
 		{
@@ -1641,6 +1648,7 @@ ExplainNode(PlanState *planstate, List *ancestors,
 								 0, es);
 			ExplainPropertyInteger("Plan Width", NULL, plan->plan_width,
 								   es);
+			ExplainPropertyFloat("Plan Calls", NULL, plan->est_calls, 0, es);
 		}
 	}
 
@@ -1763,6 +1771,17 @@ ExplainNode(PlanState *planstate, List *ancestors,
 	if (es->verbose)
 		show_plan_tlist(planstate, ancestors, es);
 
+	/*
+	 * Indicate if we did JITing for this node. When format is TEXT, only do
+	 * this when VERBOSE is enabled.
+	 */
+	if ((es->format == EXPLAIN_FORMAT_TEXT && es->verbose) ||
+		es->format != EXPLAIN_FORMAT_TEXT)
+	{
+		if (plan->jit)
+			ExplainPropertyBool("JIT", plan->jit, es);
+	}
+
 	/* unique join */
 	switch (nodeTag(plan))
 	{
diff --git a/src/backend/jit/jit.c b/src/backend/jit/jit.c
index 07461b9963..b85d773dfa 100644
--- a/src/backend/jit/jit.c
+++ b/src/backend/jit/jit.c
@@ -165,6 +165,14 @@ jit_compile_expr(struct ExprState *state)
 	/* if no jitting should be performed at all */
 	if (!(state->parent->state->es_jit_flags & PGJIT_PERFORM))
 		return false;
+	
+	/* don't jit if the plan node is missing */
+	if (state->parent->plan == NULL)
+		return false;
+
+	/* don't jit if it's not enabled for this plan node */
+	if (!state->parent->plan->jit)
+		return false;
 
 	/* or if expressions aren't JITed */
 	if (!(state->parent->state->es_jit_flags & PGJIT_EXPR))
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index 22635d2927..f2e8fe5cd7 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -2591,6 +2591,7 @@ cost_memoize_rescan(PlannerInfo *root, MemoizePath *mpath,
 		(est_cache_entries / Max(ndistinct, est_cache_entries));
 
 	Assert(hit_ratio >= 0 && hit_ratio <= 1.0);
+	mpath->est_hitratio = hit_ratio;
 
 	/*
 	 * Set the total_cost accounting for the expected cache hit ratio.  We
